/*
 * hexdump.c
 *
 * Defines a function for writing hex dumps of data.
 *
 * Kekoa Proudfoot
 * 12/7/96
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define LINE_SIZE   16
#define GROUP_SIZE  4
#define UNPRINTABLE '.'

void
hex_dump(void *buf, int len, char *prefix, FILE *file)
{
    unsigned char *b = (unsigned char *)buf;
    char           p[100] = "";
    int            i, j;

    if (prefix && prefix[0] != '\0') {
	strcat(p, prefix);
	strcat(p, " ");
    }
    
    for (i = 0; i < len / LINE_SIZE; i++) {
	fprintf(file, "%s%04x: ", p, i * LINE_SIZE);
	for (j = 0; j < LINE_SIZE; j++, b++) {
	    fprintf(file, "%02x %s", *b, ((j + 1) % GROUP_SIZE) ? "" : " ");
	}
	b -= LINE_SIZE;
	fprintf(file, " ");
	for (j = 0; j < LINE_SIZE; j++, b++) {
	    if (isprint(*b))
		putc(*b, file);
	    else
		putc(UNPRINTABLE, file);
	}
	fprintf(file, "\n");
    }
    if (len % LINE_SIZE != 0) {
	fprintf(file, "%s%04x: ", p, i * LINE_SIZE);
	for (j = 0; j < len % LINE_SIZE; j++, b++) {
	    fprintf(file, "%02x %s", *b, ((j + 1) % GROUP_SIZE) ? "" : " ");
	}
	b -= len % LINE_SIZE;
	while (j < LINE_SIZE) {
	    fprintf(file, "   %s", ((j + 1) % GROUP_SIZE) ? "" : " ");
	    j++;
	}
	fprintf(file, " ");
	for (j = 0; j < len % LINE_SIZE; j++, b++) {
	    if (isprint(*b))
		putc(*b, file);
	    else
		putc(UNPRINTABLE, file);
	}
	fprintf(file, "\n");
    }
}
